package com.example.trainingPartner.unitary;

import static org.junit.Assert.assertEquals;

import android.widget.EditText;

import androidx.test.ext.junit.runners.AndroidJUnit4;
import androidx.test.rule.ActivityTestRule;

import com.example.trainingPartner.controller.LogInActivity;
import com.example.trainingPartner.controller.SignInActivity;
import com.example.trainingPartner.dto.UserInformationDTO;
import com.example.trainingPartner.model.LogInSignInModel;
import com.example.trainingPartner.model.MyCallbBack;
import com.example.trainingPartner.utils.Utils;
import com.google.firebase.firestore.FirebaseFirestore;

import org.junit.After;
import org.junit.Before;
import org.junit.Rule;
import org.junit.Test;
import org.junit.runner.RunWith;

import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;

/**
 * Instrumented test, which will execute on an Android device.
 *
 * @see <a href="http://d.android.com/tools/testing">Testing documentation</a>
 */
@RunWith(AndroidJUnit4.class)
public class LogInTest {
    @Rule
    public ActivityTestRule<LogInActivity> iaActivityTestRule= new ActivityTestRule<LogInActivity>(LogInActivity.class);
    @Rule
    public ActivityTestRule<SignInActivity> iaActivityTestRuleSignIn= new ActivityTestRule<SignInActivity>(SignInActivity.class);

    private LogInActivity ia;
    private SignInActivity si;
    private FirebaseFirestore fb;
    @Before
    public void setUp() throws Exception {
        ia= iaActivityTestRule.getActivity();
        si = iaActivityTestRuleSignIn.getActivity();
        fb = FirebaseFirestore.getInstance();

    }

    @After
    public void tearDown() throws Exception {
        iaActivityTestRule.finishActivity();
        iaActivityTestRuleSignIn.finishActivity();

    }






    @Test
    public void checkPassword() throws InterruptedException {
        si.userRegistered("usuarioNoExistente");
        si.registerUser(new UserInformationDTO("Pedro","usuarioNoExistente","Pruebas", new Date(), 65.7, 175, true, "default", "ContraseñaPrueba@"));
        Thread.sleep(5000);
        LogInSignInModel model = new LogInSignInModel("usuarioNoExistente");
        model.getPassword(new MyCallbBack<String>() {
            @Override
            public void onCallback(String element) {
                assertEquals(true, ia.decoPassword("ContraseñaPrueba@", element));
                assertEquals(false, ia.decoPassword("ContraseñaPruebo@", element));
                fb.collection("usuarios").document("usuarioNoExistente").delete();
                ia=null;
                si = null;
            }
        });

    }





}