package com.example.trainingPartner.unitary;

import static org.junit.Assert.assertEquals;

import androidx.test.ext.junit.runners.AndroidJUnit4;
import androidx.test.rule.ActivityTestRule;

import com.example.trainingPartner.controller.LogInActivity;
import com.example.trainingPartner.controller.SignInActivity;
import com.example.trainingPartner.dto.UserInformationDTO;
import com.example.trainingPartner.model.LogInSignInModel;
import com.example.trainingPartner.model.MyCallbBack;
import com.example.trainingPartner.utils.Utils;
import com.google.firebase.firestore.FirebaseFirestore;

import org.junit.After;
import org.junit.Before;
import org.junit.Rule;
import org.junit.Test;
import org.junit.runner.RunWith;

import java.util.Date;

/**
 * Instrumented test, which will execute on an Android device.
 *
 * @see <a href="http://d.android.com/tools/testing">Testing documentation</a>
 */
@RunWith(AndroidJUnit4.class)
public class UtilsTest {




    @Test
    public void stringTimeTest(){
        assertEquals("00:00:04", Utils.returnStringTime(4));
        assertEquals("00:01:04", Utils.returnStringTime(64));
        assertEquals("01:00:04", Utils.returnStringTime(3604));
    }

    /**
     * Aquí he tenido que hacer un pequeño cambio en los calculos
     * int horas = resultInt%86400 /(3600*60); Así estaba antes
     * int horas = (resultInt%86400 /3600)*60; Ahora
     */
    @Test
    public void stringTimePartialsTest(){
        assertEquals("00:04 min/km", Utils.returnStringTimePartials(4));
        assertEquals("01:04 min/km", Utils.returnStringTimePartials(64));
        assertEquals("60:04 min/km", Utils.returnStringTimePartials(3604));
        assertEquals("75:04 min/km", Utils.returnStringTimePartials(4504));
    }

    @Test
    public void convertToMinKmTest(){
        assertEquals("--:-- min/km", Utils.convertToMinKm(0.8));
        assertEquals("60:00 min/km", Utils.convertToMinKm(1));
        assertEquals("05:00 min/km", Utils.convertToMinKm(12));
        assertEquals("03:45 min/km", Utils.convertToMinKm(16));
        assertEquals("03:19 min/km", Utils.convertToMinKm(18));
    }










}