package com.example.trainingPartner.controller;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;

import androidx.appcompat.app.AppCompatActivity;


import com.example.mapbox2.R;
import com.example.trainingPartner.model.DailyInformationModel;
import com.example.trainingPartner.model.MyCallbBack;
import com.example.trainingPartner.utils.Utils;
import com.example.trainingPartner.model.LogInSignInModel;
import com.google.android.material.snackbar.Snackbar;

import java.util.Calendar;
import java.util.List;

public class LogInActivity extends AppCompatActivity {
    private LogInSignInModel model;
    private String username, password;
    private SharedPreferences sharedPref;
    private SharedPreferences sharedPreferences;
    public static ProgressDialog dialog;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        dialog = new ProgressDialog(this, R.style.ProgressDialogStyle);
        dialog.setCancelable(false);
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_log_in_activitity);
        sharedPref = this.getSharedPreferences(
                "users", Context.MODE_PRIVATE);
        sharedPreferences = this.getSharedPreferences("stepCounter",Context.MODE_PRIVATE);
        goToSignIn();
        Utils.deActivateTouchingOutside(this);
        buttonLogIn();
    }

    private void goToSignIn(){
        Button b = findViewById(R.id.buttonGoToSigIn);
        b.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(getApplicationContext(), SignInActivity.class);
                startActivity(intent);
                finish();
            }
        });
    }

    private void buttonLogIn(){
        Button logIn = findViewById(R.id.buttonLogIn);
        logIn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                comprobaciones();

            }
        });
    }

    private void iniciateMain(){
        String username = Utils.getUserName(this);

        if (!username.equals("None") && !username.equals("") && Utils.getUserName(this)!=null){
            setSteps();
        }

    }

    public void setSteps(){
        DailyInformationModel model2 =new DailyInformationModel(username);
        model2.getLastConnection(new MyCallbBack<Calendar>() {
            @Override
            public void onCallback(Calendar element) {
                int day = element.get(Calendar.DAY_OF_MONTH);
                int month = element.get(Calendar.MONTH);
                int year = element.get(Calendar.YEAR);
                model.getSteps(new MyCallbBack<Integer>() {
                    @Override
                    public void onCallback(Integer steps) {
                        SharedPreferences.Editor edit =sharedPreferences.edit();
                        edit.putInt("stepCount", steps);
                        System.out.println(steps);
                        edit.apply();
                        startActivity();
                    }
                }, day, month, year);

            }
        });



    }

    private void startActivity(){
        Intent intent = new Intent(this, MainActivity.class);
        startActivity(intent);
        finish();
    }

    private void comprobaciones(){
        boolean a = Utils.hasText(R.id.editTextTextUserNameLog, this);
        boolean b = Utils.hasText(R.id.editTextTextPasswordLog, this);
        if (!a || !b){
            mostrarError("Todos los campos deben de estar completos");
        }else{
            username =((EditText)findViewById(R.id.editTextTextUserNameLog)).getText().toString();
            password =((EditText)findViewById(R.id.editTextTextPasswordLog)).getText().toString();
            userExists(username, password);
        }

    }

    public void userExists(String us, String pass){
        model = new LogInSignInModel(us);
        model.getUserNames(new MyCallbBack<List<String>>() {
            @Override
            public void onCallback(List<String> element) {
                if (element.contains(us)){
                    checkPassword(pass);
                }else{
                    mostrarError("El usuario no existe");
                }
            }
        });

    }




    private void mostrarError( String text){
        Snackbar.make(findViewById(R.id.coordinatorLayoutLogIn), text,
                Snackbar.LENGTH_SHORT).setBackgroundTint(getResources().getColor(R.color.anaranjado)).show();
    }

    public void checkPassword(String ps){
        model.getPassword(new MyCallbBack<String>() {
            @Override
            public void onCallback(String element) {
                if (decoPassword(ps,element)){
                    dialog.show();
                    SharedPreferences.Editor editor = sharedPref.edit();
                    editor.putString("username", username);
                    editor.apply();
                    iniciateMain();
                }else{
                    mostrarError("El nombre de usuario o contraseña no es correcto");
                }
            }
        });

    }

    public boolean decoPassword(String ps, String element){
        if (element.equals(Utils.getMD5(ps))){
            return true;
        }else{
           return false;
        }
    }







}
