package com.example.trainingPartner.controller;

import androidx.appcompat.app.AppCompatActivity;

import android.app.DatePickerDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.RadioButton;

import com.example.mapbox2.R;
import com.example.trainingPartner.model.MyCallbBack;
import com.example.trainingPartner.utils.Utils;
import com.example.trainingPartner.controller.fragment.DatePickerFragment;
import com.example.trainingPartner.dto.UserInformationDTO;
import com.example.trainingPartner.model.LogInSignInModel;
import com.google.android.material.snackbar.Snackbar;

import java.util.Date;
import java.util.List;

public class SignInActivity extends  AppCompatActivity {
    private double weight, height;
    private String name, surname, username, password, birth;
    private SharedPreferences sharedPref;
    private boolean sex;
    private EditText date;
    private Date d;
    private static final String regex = "^(?=.*[a-z])(?=.*[A-Z])(?=.*[@#$%^&+=!_-])(?=\\S+$).{8,}$";
    private static final String minusculasMayusculas = "^(?=.*[a-z])(?=.*[A-Z]).+$";
    private static final String especial = ".*[^a-zA-Z0-9].*";
    private static final String longitud = ".{8,}";
    private LogInSignInModel model;
    public static ProgressDialog dialog;
    private SharedPreferences sharedPreferences;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //Utils.deleteSharedPreferences(this);
        sharedPreferences = this.getSharedPreferences("stepCounter",MODE_PRIVATE);
        dialog = new ProgressDialog(this, R.style.ProgressDialogStyle);
        dialog.setCancelable(false);
        setContentView(R.layout.activity_sign_in_activitity);
        iniciateMain();
        goToLogin();
        datePicker();
        buttonSignIn();
        Utils.deActivateTouchingOutside(this);
        sharedPref = this.getSharedPreferences(
                "users", Context.MODE_PRIVATE);
    }

    private void goToLogin(){
        Button b = findViewById(R.id.buttonGoToLogIn);
        b.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(getApplicationContext(), LogInActivity.class);
                startActivity(intent);
                finish();
            }
        });

    }
    public SharedPreferences getSharedPreferencesSteps(){
        return sharedPreferences;
    }
    public SharedPreferences getSharedPreferencesUsers(){
        return sharedPref;
    }


    private void buttonSignIn(){
        Button logIn = findViewById(R.id.buttonSignIn);
        logIn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                comprobaciones();
            }
        });
    }

    private void registrar(){
        dialog.show();
        name = ((EditText)findViewById(R.id.editTextTextPersonName)).getText().toString();
        surname = ((EditText)findViewById(R.id.editTextTextPersonSurName)).getText().toString();
        username  = ((EditText)findViewById(R.id.editTextTextUserName)).getText().toString();
        password = ((EditText)findViewById(R.id.editTextTextPassword)).getText().toString();
        birth = ((EditText)findViewById(R.id.editTextDate)).getText().toString();
        sex = ((RadioButton)findViewById(R.id.radioButtonMale)).isChecked();
        weight = Double.parseDouble(((EditText)findViewById(R.id.editTextWeightSignIn)).getText().toString());
        height = Double.parseDouble(((EditText)findViewById(R.id.editTextHeightSignIn)).getText().toString());
        UserInformationDTO user = new UserInformationDTO(name, username,surname, d, weight, height, sex, "default", password);
        registerUser(user);
    }

    public void registerUser(UserInformationDTO user){
        model.signIn(user);
        //Ponemos el nomnre de usuario
        SharedPreferences.Editor editor = sharedPref.edit();
        editor.putString("username", username);
        //Ponemos los pasos a 0
        SharedPreferences.Editor edit =sharedPreferences.edit();
        edit.putInt("stepCount", 0);
        edit.apply();
        editor.apply();
        iniciateMain();
    }

    private void iniciateMain(){
        String username = Utils.getUserName(this);
        if (!username.equals("None") && !username.equals("") && Utils.getUserName(this)!=null){
            Intent intent = new Intent(this, MainActivity.class);
            startActivity(intent);
            finish();
        }

    }

    private void comprobaciones(){
        EditText passw = (EditText)findViewById(R.id.editTextTextPassword);
        boolean a = Utils.hasText(R.id.editTextTextUserName, this);
        boolean b= Utils.hasText(R.id.editTextTextPersonSurName, this);
        boolean c= Utils.hasText(R.id.editTextTextPersonName, this);
        boolean d= Utils.hasText(R.id.editTextTextPassword, this);
        boolean e= Utils.hasText(R.id.editTextWeightSignIn, this);
        boolean f= Utils.hasText(R.id.editTextHeightSignIn, this);
        boolean h= Utils.hasText(R.id.editTextDate, this);

        if(!(a&&b&&c&&d&&e&&f&&h)){
            mostrarError("Todos los campos deben de estar completos");

        }else{
            boolean g = correctPassword((passw).getText().toString());
            if (!g){
                passw.setText("");
            }else{
                String s = ((EditText)findViewById(R.id.editTextTextUserName)).getText().toString();
                userRegistered(s);
            }
        }

    }

    public void userRegistered(String s){
        if (Utils.hasStringText(s)){
            model = new LogInSignInModel(username);
            model.getUserNames(new MyCallbBack<List<String>>() {
                @Override
                public void onCallback(List<String> element) {
                    if (element.contains(s)){
                        mostrarError("El nombre de usuario ya está registrado en el sistema");
                        ((EditText) findViewById(R.id.editTextTextUserName)).setText("");
                    }else{
                        if (!checkHeight(findViewById(R.id.editTextHeightSignIn))){
                            mostrarError("La altura no es correcta");
                        }else if (checkWeight(findViewById(R.id.editTextWeightSignIn))){
                            registrar();
                        }
                    }
                }
            });
        }

    }



    public boolean checkHeight(EditText editText){
        if (editText== null)
            return false;
        String s = editText.getText().toString();
        try{
            int height = Integer.parseInt(s);
            if (height>250 || height < 60){
                editText.setText("");
                return false;
            }
        }catch(NumberFormatException e){
            return false;
        }
        return true;
    }



    private void mostrarError( String text){
        Snackbar.make(findViewById(R.id.mainLayoutSignIn), text,
                        Snackbar.LENGTH_SHORT).setBackgroundTint(getResources().getColor(R.color.anaranjado)).show();
    }

    public boolean correctPassword(String text){
        if (!text.matches(longitud)){
            mostrarError("La contraseña debe de contener 8 caracteres como mínimo");
            return false;
        }else if ( !text.matches(minusculasMayusculas)){
            mostrarError("La contraseña debe de contener caracteres en mayusculas y minusculas");
            return false;
        }else if(!text.matches(especial)){
            mostrarError("La contraseña debe de contener al menos un caracter especial (@#$%^&+=!_-)");
            return false;
        }else if(!text.matches(regex)){
            mostrarError("La contraseña contiene algun caracter vacío");
            return false;
        }
        return true;
    }



    private void datePicker(){
        date = findViewById(R.id.editTextDate);
        date.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                showDatePickerDialog();
            }
        });
    }

    private void showDatePickerDialog() {
        DatePickerFragment newFragment = DatePickerFragment.newInstance(new DatePickerDialog.OnDateSetListener() {
            @Override
            public void onDateSet(DatePicker datePicker, int year, int month, int day) {
                // +1 because January is zero
                final String selectedDate = day + " / " + (month+1) + " / " + year;
                d = new Date(year-1900, month, day);
                if (correctDate(d)){
                    date.setText(selectedDate);
                }else{
                    mostrarError("La fecha introducida es incorrecta");
                }

            }
        });
        newFragment.show(this.getSupportFragmentManager(), "datePicker");
    }

    public boolean correctDate(Date date){
        if (date.after(new Date())){
            return false;
        }
        return true;
    }

    public boolean checkWeight(EditText editText){
        if(editText==null)
            return false;
        String w = editText.getText().toString();
        if (!Utils.hasStringText(w) )
            return false;
        Double d = Double.parseDouble(w);
        if (!Utils.matchesWeight(editText)){
            mostrarError("Formato de peso incorrecto, dos decimales como máximo");
            editText.setText("");
            return false;
        }else if (d >600 || d < 25){
            mostrarError("Peso incorrecto");
            editText.setText("");
            return false;
        }
        return true;
    }


}

