package com.example.trainingPartner.controller.dialog;

import android.app.Dialog;
import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.example.mapbox2.R;
import com.example.trainingPartner.model.DailyInformationModel;

/**
 * Clase que sirve para cambiar los datos de peso y altura del usuario
 */
public abstract class ChangeDataDialog {
    Dialog dialog;
    Context context;
    TextView textInformation;
    DailyInformationModel model;
    TextView format ;

    /**
     * Constructor
     * @param cont
     * @param model
     */
    public ChangeDataDialog(Context cont, DailyInformationModel model){
        this.context = cont;
        this.model = model;
        dialog = new Dialog(context);
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
        dialog.setContentView(R.layout.dialog_change_weight_height);
        dialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        format = dialog.findViewById(R.id.textViewFormat);
        textInformation = dialog.findViewById(R.id.textViewInformationChange);
        setInformation();

    }

    /**
     * Cambia la información del peso o la altura
     */
    public void setInformation(){
        Button change = this.dialog.findViewById(R.id.buttonChange);
        EditText text = dialog.findViewById(R.id.editTextNewValue);
        setFormatAndInfo(text);
        change.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (isCorrectFormat(text)){
                    dialog.dismiss();
                    saveData(String.valueOf(text.getText()));

                }else{
                    text.setText("");
                    TextView format = dialog.findViewById(R.id.textViewFormat);
                    format.setVisibility(View.VISIBLE);
                }
            }
        });
        dialog.show();

    }

    /**
     * Métodos que se van a sobreescribir
     * @param text
     * @return
     */
    public abstract boolean isCorrectFormat(EditText text);
    public abstract void setFormatAndInfo(EditText text);
    public abstract void saveData(String data);





}