package com.example.trainingPartner.controller.dialog;

import android.app.Activity;
import android.content.Context;
import android.widget.EditText;
import android.widget.TextView;

import com.example.mapbox2.R;
import com.example.trainingPartner.utils.Utils;
import com.example.trainingPartner.controller.fragment.MainWindowFragment;
import com.example.trainingPartner.model.DailyInformationModel;

/**
 * Clase que simula el dialog de cambio de peso
 */
public class ChangeWeightDialog extends ChangeDataDialog{

    public ChangeWeightDialog(Context cont, DailyInformationModel model) {
        super(cont, model);

    }

    /**
     * comprueba el formato
     * @param text
     * @return
     */
    @Override
    public boolean isCorrectFormat(EditText text){
        return Utils.matchesWeight(text) && inTheLimits(text) ;
    }

    /**
     * Comprueba que el peso este dentro de los limites
     * @param text
     * @return
     */
    private boolean inTheLimits(EditText text){
        String s = text.getText().toString();
        Double d = Double.parseDouble(s);
        return d <= 600 && d >= 25;
    }

    /**
     * Muetsra el error de formato
     * @param text
     */
    @Override
    public void setFormatAndInfo(EditText text) {
        text.setHint("XXX.XX");
        format.setText("Formato: XXX.XX kg");
        textInformation.setText("Introduce el nuevo valor para el peso");

    }

    /**
     * Guarda los datos del usuario
     * @param data
     */
    @Override
    public void saveData(String data) {
        model.saveWeight(data);
        TextView tx = ((Activity) context).findViewById(R.id.textViewWeight);
        tx.setText(data + " kg");
        MainWindowFragment.dto.setWeight(Double.parseDouble(data));
        MainWindowFragment.dto.calcularLongitudPaso();
    }


}
