package com.example.trainingPartner.controller.dialog;

import android.app.Activity;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.view.View;
import android.view.Window;
import android.widget.Button;

import com.example.mapbox2.R;
import com.example.trainingPartner.controller.MainActivity;
import com.example.trainingPartner.model.TrainDetailsModel;

/**
 * Método que simula el dialog de eliminación de una actividad
 */
public class DeleteDialog {
    private Dialog dialog;
    private Context context;

    public DeleteDialog(Context cont, TrainDetailsModel model, ProgressDialog dialog){
        this.context = cont;
        this.dialog = new Dialog(context);
        this.dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
        this.dialog.setContentView(R.layout.dialog_sure_delete);
        this.dialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));

        buttonActions(model, dialog);
        this.dialog.show();

    }


    /**
     * Acciones de los botones
     * @param model
     * @param charge
     */
    private void buttonActions(TrainDetailsModel model, ProgressDialog charge){

        Button aceptar = dialog.findViewById(R.id.buttonAceptarDelete);
        Button cancelar = dialog.findViewById(R.id.buttonCancelarDelete);
        cancelar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dialog.dismiss();
            }
        });

        aceptar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                delete(charge,model);
            }
        });

    }

    /**
     * Elimina la actividad
     * @param charge
     * @param model
     */
    private void delete(ProgressDialog charge, TrainDetailsModel model){
        charge.show();
        model.deleteActivity();
        Activity act = (Activity) context;
        startActivity(MainActivity.class);
        act.finish();
        dialog.dismiss();
    }

    /**
     * Inicia la actividad
     * @param c
     */
    private void startActivity(Class c){
        Intent intent = new Intent(context, c);
        context.startActivity(intent);
        dialog.dismiss();
    }





}