package com.example.trainingPartner.controller.dialog;

import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.view.View;
import android.view.Window;
import android.widget.Button;

import com.example.mapbox2.R;
import com.example.trainingPartner.controller.ManualRecordActivity;
import com.example.trainingPartner.controller.RecordActivity;
import com.example.trainingPartner.utils.Utils;
import com.google.android.material.bottomnavigation.BottomNavigationView;

/**
 * Dialog para seleccionar el modo de la actividad a realizar
 */
public class SelectModeDialog{
    private Dialog dialog;
    private Context context;

    public SelectModeDialog(Context cont, int type){
        this.context = cont;
        dialog = new Dialog(context);
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
        dialog.setContentView(R.layout.dialog_select_mode);
        dialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));

        buttonActions();
        dialog.setOnCancelListener(new DialogInterface.OnCancelListener() {
            @Override
            public void onCancel(DialogInterface dialogInterface) {
                BottomNavigationView nav = ((Activity) context).findViewById(R.id.navigationView);
                nav.setSelectedItemId(type);
                dialogInterface.dismiss();
            }
        });
        dialog.show();

    }


    /**
     * Acciones de los botones
     */
    private void buttonActions(){

        Button automatico = dialog.findViewById(R.id.buttonAceptarDelete);
        Button manual = dialog.findViewById(R.id.buttonCancelarDelete);
        automatico.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Utils.setRequestingLocationUpdates(dialog.getContext(), false);
                startActivity(RecordActivity.class);

            }
        });

        manual.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                startActivity(ManualRecordActivity.class);
            }
        });
    }

    private void startActivity(Class c){
        Intent intent = new Intent(context, c);
        context.startActivity(intent);
        dialog.dismiss();

    }







}