package com.example.trainingPartner.controller.dialog;

import android.app.Dialog;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.view.View;
import android.view.Window;
import android.widget.Button;

import com.example.mapbox2.R;
import com.example.trainingPartner.utils.Utils;
import com.example.trainingPartner.controller.MainActivity;
import com.example.trainingPartner.controller.SignInActivity;

/**
 * Dialog para cerrar la sesión
 */
public class SignOutDialog {
    private Dialog dialog;
    private Context context;

    public SignOutDialog(Context cont){
        this.context = cont;
        dialog = new Dialog(context);
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
        dialog.setContentView(R.layout.dialog_sure_exit);
        dialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));

        buttonActions();
        dialog.show();

    }


    /**
     * Acciones de los botones
     */
    private void buttonActions(){

        Button aceptar = dialog.findViewById(R.id.buttonAceptarDelete);
        Button cancelar = dialog.findViewById(R.id.buttonCancelarDelete);
        cancelar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dialog.dismiss();
            }
        });

        aceptar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                signOut();
            }
        });
    }

    /**
     * Cierra sesión
     */
    private void signOut(){
        MainActivity act = (MainActivity) context;
        act.stopSteps();
        act.saveStepsLogOut();
        act.finish();

        Utils.deleteSharedPreferences(act);
        startActivity(SignInActivity.class);
    }

    /**
     * Inicia la actividad
     * @param c
     */
    private void startActivity(Class c){
        Intent intent = new Intent(context, c);
        context.startActivity(intent);
        dialog.dismiss();
    }





}