package com.example.trainingPartner.controller.fragment;

import android.annotation.SuppressLint;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.fragment.app.Fragment;

import com.example.mapbox2.R;
import com.example.trainingPartner.dto.FastestKilometersDTO;
import com.example.trainingPartner.model.MyCallbBack;
import com.example.trainingPartner.utils.Utils;
import com.example.trainingPartner.model.PredictionsModel;

public class PredictionsFragment extends Fragment {
    private View v;
    private TextView one,ten, half,marathon;
    private String oneS, tenS, halfS, marathonS;
    private PredictionsModel model;
    private View customLayout, customLayout2, customLayout3, customLayout4;
    private ProgressDialog dialog;

    private static final int PERCENT_ONE = 105;
    private static final int PERCENT_TEN = 100;
    private static final int PERCENT_HALF = 95;
    private static final int PERCENT_MARATHON = 85;

    public PredictionsFragment(ProgressDialog dialog) {
        this.dialog=dialog;
    }
    public PredictionsFragment(){}

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        String username = Utils.getUserName(getActivity());
        model = new PredictionsModel(username);


    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        v = inflater.inflate(R.layout.fragment_predictions, container, false);
        preConditions();
        showPredictions();
        if (dialog!= null)
            dialog.dismiss();
        return v;
    }

    private void showPredictions(){
        View notEnought = v.findViewById(R.id.notEnoughActivities);
        model.moreThanThreeActivities(new MyCallbBack<Boolean>() {
            @Override
            public void onCallback(Boolean element) {
                if (element){
                    customLayout.setVisibility(View.VISIBLE);
                    customLayout2.setVisibility(View.VISIBLE);
                    customLayout3.setVisibility(View.VISIBLE);
                    customLayout4.setVisibility(View.VISIBLE);
                    notEnought.setVisibility(View.GONE);
                    model.getFastestKilometers(new MyCallbBack<FastestKilometersDTO>() {
                        FastestKilometersDTO dto;
                        @Override
                        public void onCallback(FastestKilometersDTO element) {
                            dto = element;
                            one.setText(getOne());
                            ten.setText(getTen());
                            half.setText(getHalf());
                            marathon.setText(getMarathon());
                        }

                        private String getOne(){
                            double speed =  (dto.kilometer1 * PERCENT_ONE)/100;
                            oneS = Utils.convertToMinKm(speed);
                            return oneS;
                        }
                        private String getTen(){
                            double speed= (dto.getMean()* PERCENT_TEN)/100;
                            tenS = Utils.convertToMinKm(speed);
                            return tenS;
                        }
                        private String getHalf(){
                            double speed=  (dto.getMean()* PERCENT_HALF)/100;
                            halfS = Utils.convertToMinKm(speed);
                            return halfS;
                        }
                        private String getMarathon(){
                            double speed=  (dto.getMean()* PERCENT_MARATHON)/100;
                            marathonS = Utils.convertToMinKm(speed);
                            return marathonS;
                        }
                    });


                }else{
                    customLayout.setVisibility(View.GONE);
                    customLayout2.setVisibility(View.GONE);
                    customLayout3.setVisibility(View.GONE);
                    customLayout4.setVisibility(View.GONE);
                    notEnought.setVisibility(View.VISIBLE);

                }
            }
        });




    }

    public String getMarathonS(){
        return marathonS;
    }
    public String getOneS(){
        return oneS;
    }
    public String getTenS(){
        return tenS;
    }
    public String getHalfS(){
        return halfS;
    }

    public PredictionsModel getModel(){
        return model;
    }

    @SuppressLint("ResourceAsColor")
    private void preConditions(){
        customLayout = v.findViewById(R.id.one_pred);
        one = customLayout.findViewById(R.id.textViewDataPrediction);


        customLayout2 = v.findViewById(R.id.ten_pred);
        ten = customLayout2.findViewById(R.id.textViewDataPrediction);
        TextView txt = customLayout2.findViewById(R.id.textViewTitlePrediction);
        txt.setText("10km:");
        customLayout2.setBackgroundResource(R.drawable.linear_alyout_rounded);


        customLayout3 = v.findViewById(R.id.half_pred);
        half = customLayout3.findViewById(R.id.textViewDataPrediction);
        TextView txt2 = customLayout3.findViewById(R.id.textViewTitlePrediction);
        txt2.setText("21,0975km:");

        customLayout3.setBackgroundResource(R.drawable.linear_layout_rounded_third_gray);



        customLayout4 = v.findViewById(R.id.marathon_pred);
        marathon = customLayout4.findViewById(R.id.textViewDataPrediction);
        TextView txt3 = customLayout4.findViewById(R.id.textViewTitlePrediction);
        txt3.setText("42,195km:");
        customLayout4.setBackgroundResource(R.drawable.linear_layout_rounded_fourth_gray);
        txt3.setTextColor(R.color.black);
        marathon.setTextColor(R.color.black);

    }
}
