package com.example.trainingPartner.dto.activityDto;

import com.example.trainingPartner.utils.Utils;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

public abstract class ActivityDTO {
    public static final boolean MANUAL = true;
    public static final boolean AUTOMATIC = false;
    public Double distance;
    public Double time;
    public Double speedMean;
    private String fecha;
    private String hour;
    private Calendar date;
    private boolean type;

    public ActivityDTO(double distance, double time, boolean type, Calendar calendar){
        this.distance = distance;
        this.type=type;
        this.time=time;
        setMeanSpeed();
        DateFormat dateFormat = new SimpleDateFormat("EEE, d MMM yyyy");
        DateFormat hourFormat = new SimpleDateFormat("HH:mm:ss");
        this.hour = hourFormat.format(new Date());
        this.fecha ="\t"+calendar.get(Calendar.DAY_OF_MONTH)+"/"+(calendar.get(Calendar.MONTH)+1)+"/"+calendar.get(Calendar.YEAR);
        this.date = calendar;

    }

    public ActivityDTO(double distance, double time, boolean type,String hour, Calendar calendar){
        this.distance = distance;
        this.type=type;
        this.time=time;
        setMeanSpeed();
        DateFormat dateFormat = new SimpleDateFormat("EEE, d MMM yyyy");
        this.hour = hour;
        this.fecha ="\t"+calendar.get(Calendar.DAY_OF_MONTH)+"/"+calendar.get(Calendar.MONTH)+"/"+calendar.get(Calendar.YEAR);
        this.date = calendar;
    }
    public double getDistance(){
        return Utils.roundTwoDecimals(distance);
    }
    public double getTime(){return Utils.roundTwoDecimals(time);}
    public String getFormatHour(){
        return Utils.returnStringTime(time);
    }
    public String getFecha(){
        return fecha;
    }
    public String getHour(){
        return hour;
    }
    public void setHour(String h){ this.hour = h;}
    public boolean getType(){return type;}
    public double getSpeedMean(){
        return speedMean;
    }
    public String getMinKmMean(){
        return Utils.convertToMinKm(speedMean);
    }

    private void setMeanSpeed(){
        speedMean= calculateSpeed(time,distance);
    }
    double calculateSpeed(double time, double distance){
        double hours = time/3600;
        double sp = distance/hours;
        return Utils.roundTwoDecimals(sp);
    }

    public Map<String, Object> setValuesToSave(){
        Map<String, Object> actividad = new HashMap<>();
        actividad.put("distance", getDistance());
        actividad.put("time", getTime());
        actividad.put("type", getType());
        return actividad;
    }

    public Calendar getDate(){
        return date;
    }

    public String getYear(){
        return date.get(Calendar.YEAR)+"";
    }

    public String getMonth(){
        return date.get(Calendar.MONTH)+"";
    }

    public String getDay(){
        return date.get(Calendar.DAY_OF_MONTH)+"";
    }


}
