package com.example.trainingPartner.model;

import androidx.annotation.NonNull;

import com.example.trainingPartner.dto.FastestKilometersDTO;
import com.google.android.gms.tasks.OnFailureListener;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.firestore.DocumentSnapshot;
import com.google.firebase.firestore.SetOptions;

import java.util.HashMap;

public class ActivitiesModel extends Model{

    public ActivitiesModel(String user){
        super(user);

    }
    public void getNumberOfActivities(MyCallbBack<Integer> callback){
        Task<DocumentSnapshot> document = db.collection("usuarios").document(username).get().addOnFailureListener(new OnFailureListener() {
            @Override
            public void onFailure(@NonNull Exception e) {
                try {
                    throw new Exception( e);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }).addOnSuccessListener(new OnSuccessListener<DocumentSnapshot>() {
            @Override
            public void onSuccess(DocumentSnapshot documentSnapshot) {
                long s = documentSnapshot.getLong("numberOfActivities");
                Integer numberOfActivities = Math.toIntExact(s);
                callback.onCallback(numberOfActivities);
            }
        });

    }

    public void updateNumberOfActivities(int number){
        getNumberOfActivities(new MyCallbBack<Integer>() {
            @Override
            public void onCallback(Integer activities) {
                if (activities >=0){
                    HashMap<String, Integer> act = new HashMap<>();
                    act.put("numberOfActivities", activities + number);
                    db.collection("usuarios").document(username).set(act, SetOptions.merge());
                }
            }
        });


    }

    public void getFastestKilometers(MyCallbBack<FastestKilometersDTO> callback){
        Task<DocumentSnapshot> document =  db.collection("usuarios").document(username).
                collection("records").document("kilometros").get().addOnFailureListener(new OnFailureListener() {
                    @Override
                    public void onFailure(@NonNull Exception e) {
                        try {
                            throw new Exception( e);
                        } catch (Exception ex) {
                            ex.printStackTrace();
                        }
                    }
                }).addOnSuccessListener(new OnSuccessListener<DocumentSnapshot>() {
                    @Override
                    public void onSuccess(DocumentSnapshot documentSnapshot) {
                        double km1 = setKilometer("km1", documentSnapshot);
                        double km2 = setKilometer("km2", documentSnapshot);
                        double km3 = setKilometer("km3", documentSnapshot);
                        FastestKilometersDTO fastestKilometersDTO = new FastestKilometersDTO(km1, km2, km3);
                        callback.onCallback(fastestKilometersDTO);
                    }
                });

    }


    private double setKilometer(String km, DocumentSnapshot document){
        if (document.contains(km)){
            return document.getDouble(km);
        }else{
            return 0;
        }
    }

    public void updateFastestKilometers(FastestKilometersDTO fastestKilometersDTO){
        if (fastestKilometersDTO.changed){
            db.collection("usuarios").document(username).
                    collection("records").document("kilometros").set(fastestKilometersDTO.getKilometers());
        }
    }
}
