package com.example.trainingPartner.model;

import androidx.annotation.NonNull;

import com.google.android.gms.tasks.OnFailureListener;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.firestore.DocumentSnapshot;
import com.google.firebase.firestore.QuerySnapshot;
import com.prolificinteractive.materialcalendarview.CalendarDay;

import java.util.Calendar;
import java.util.HashSet;
import java.util.List;

public class HistoryModel extends Model {

    public HistoryModel(String user) {
        super(user);

    }


    public void getDays(int year, int month, MyCallbBack myCallbBack) {
        HashSet<CalendarDay> enableDays = new HashSet<>();
        Task<QuerySnapshot> collection = db.collection("usuarios").document(username).
                collection("año").document(year + "").collection(month + "").get().addOnFailureListener(new OnFailureListener() {
                    @Override
                    public void onFailure(@NonNull Exception e) {
                        try {
                            throw new Exception(e);
                        } catch (Exception ex) {
                            ex.printStackTrace();
                        }
                    }
                }).addOnSuccessListener(new OnSuccessListener<QuerySnapshot>() {
                    @Override
                    public void onSuccess(QuerySnapshot documents) {
                        Calendar calendar = Calendar.getInstance();
                        for (DocumentSnapshot document : documents) {
                            String s = document.getId();
                            if (!(calendar.get(Calendar.YEAR) == year && calendar.get(Calendar.MONTH) == month
                                    && calendar.get(Calendar.DAY_OF_MONTH) == Integer.parseInt(s))) {
                                enableDays.add(CalendarDay.from(year, month, Integer.parseInt(s)));
                            }
                        }
                        myCallbBack.onCallback(enableDays);
                    }
                });
    }
}

