package com.example.trainingPartner.model;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

import androidx.annotation.NonNull;

import com.example.trainingPartner.dto.UserInformationDTO;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.OnFailureListener;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.firestore.DocumentSnapshot;
import com.google.firebase.firestore.QuerySnapshot;
import com.google.firebase.storage.StorageReference;
import com.google.firebase.storage.UploadTask;

import java.io.ByteArrayOutputStream;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * En esta clase se accede a los datos de firebase de una manerá síncrona para realizar las
 * comprobaciones correctamente.
 */
public class LogInSignInModel extends Model{

    public LogInSignInModel(String user){
        super(user);
    }

    public void getUserNames(MyCallbBack<List<String>> callbBack) {
        List<String> usernames = new ArrayList<>();
        Task<QuerySnapshot> collection = db.collection("usuarios").get().addOnFailureListener(new OnFailureListener() {
            @Override
            public void onFailure(@NonNull Exception e) {
                try {
                    throw new Exception(e);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }).addOnSuccessListener(new OnSuccessListener<QuerySnapshot>() {
            @Override
            public void onSuccess(QuerySnapshot queryDocumentSnapshots) {
                for (DocumentSnapshot document : queryDocumentSnapshots) {
                    usernames.add(document.getId());
                }
                callbBack.onCallback(usernames);

            }
        });
    }

    public void getPassword(MyCallbBack<String> callback) {
        List<String> usernames = new ArrayList<>();
        Task<DocumentSnapshot> document = db.collection("usuarios").document(username).get().addOnFailureListener(new OnFailureListener() {
            @Override
            public void onFailure(@NonNull Exception e) {
                try {
                    throw new Exception(e);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }).addOnCompleteListener(new OnCompleteListener<DocumentSnapshot>() {
            @Override
            public void onComplete(@NonNull Task<DocumentSnapshot> task) {
                DocumentSnapshot documentSnapshot = task.getResult();
                String password = documentSnapshot.getString("password");
                if (password == null)
                    callback.onCallback("NotFound");
                callback.onCallback(password);
            }

        });

    }

    public void getSteps(MyCallbBack<Integer> callback, int day, int month, int year) {
        Calendar calendar = Calendar.getInstance();
        Task<DocumentSnapshot> document = db.collection("usuarios").document(username).collection("año").
                document(year+""). collection(month+"").
        document(day+"").get().addOnFailureListener(new OnFailureListener() {
            @Override
            public void onFailure(@NonNull Exception e) {
                try {
                    throw new Exception(e);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }).addOnSuccessListener(new OnSuccessListener<DocumentSnapshot>() {
                    @Override
                    public void onSuccess(DocumentSnapshot documentSnapshot) {
                        try{
                            long steps = (long) documentSnapshot.get("steps");
                            int value = Math.toIntExact(steps);
                            callback.onCallback(value);
                        }catch (NullPointerException e){
                            callback.onCallback(0);
                        }
                    }
                });

    }

    public void signIn(UserInformationDTO dto){
        db.collection("usuarios").document(dto.getUsername()).set( dto.getInformation());

        Map<String, Integer> lastConnection = new HashMap<>();
        Calendar calendar = Calendar.getInstance();
        lastConnection.put("year", calendar.get(Calendar.YEAR));
        lastConnection.put("month", calendar.get(Calendar.MONTH));
        lastConnection.put("day", calendar.get(Calendar.DAY_OF_MONTH));
        db.collection("registro").document(dto.getUsername()).set( lastConnection);
    }




}
