package com.example.trainingPartner.model;

import com.example.trainingPartner.dto.FastestKilometersDTO;
import com.example.trainingPartner.dto.activityDto.ActivityDTO;
import com.google.android.gms.tasks.OnSuccessListener;

public class RecordModel extends ActivitiesModel{
    public RecordModel(String user){
        super(user);
    }


    public void saveActivity(ActivityDTO actividadDTO, MyCallbBack<Boolean> callback){

        db.collection("usuarios").document(username).
                collection("año").document(actividadDTO.getYear()).collection(actividadDTO.getMonth()).
                document(actividadDTO.getDay()).collection("actividades").document(actividadDTO.getHour())
                .set(actividadDTO.setValuesToSave()).addOnSuccessListener(new OnSuccessListener<Void>() {
                    @Override
                    public void onSuccess(Void unused) {
                        updateActivities(actividadDTO);
                        callback.onCallback(true);


                    }
                });

    }

    private void updateActivities(ActivityDTO actividadDTO){
        if (actividadDTO.getDistance() >= 3){
            updateNumberOfActivities(1);
            updateFastestKilometer(actividadDTO);
        }
    }

    private void updateFastestKilometer(ActivityDTO dto){
        getFastestKilometers(new MyCallbBack<FastestKilometersDTO>() {
            @Override
            public void onCallback(FastestKilometersDTO fastest) {
                fastest.setKilometer(dto.speedMean);
                updateFastestKilometers(fastest);
            }
        });

    }







}


