package com.example.trainingPartner.model;

import androidx.annotation.NonNull;

import com.example.trainingPartner.utils.Utils;
import com.example.trainingPartner.dto.activityDto.ActivityDTO;
import com.example.trainingPartner.dto.activityDto.ManualActivityDTO;
import com.google.android.gms.tasks.OnFailureListener;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.firestore.DocumentSnapshot;

import java.util.Calendar;

public class TrainDetailsModel extends ActivitiesModel{
    private Double distance = 0.0;
    private Double time =0.0;
    private ActivityDTO actividadDTO;
    private boolean type;

    private String year,month,day,hour;
    private Calendar calendar;


    public TrainDetailsModel(String year, String month, String day,String hour, Calendar calendar, String user){
        super(user);
        this.year=year;
        this.month=month;
        this.day=day;
        this.hour=hour;
        System.out.println(year + month+day+hour);
        this.calendar = calendar;
    }
    public void getData(MyCallbBack<ActivityDTO> callback) {
        System.out.println(username+ " / "+year+" / "+month+" / "+day+" / actividades / "+hour);
        db.collection("usuarios").document(username).
                collection("año").document(year).collection(month).
                document(day).collection("actividades").document(hour)
                .get().addOnFailureListener(new OnFailureListener() {
                    @Override
                    public void onFailure(@NonNull Exception e) {
                        try {
                            throw new Exception( e);
                        } catch (Exception ex) {
                            ex.printStackTrace();
                        }
                    }
                }).addOnSuccessListener(new OnSuccessListener<DocumentSnapshot>() {
                    @Override
                    public void onSuccess(DocumentSnapshot documentSnapshot) {
                        try {
                            type = documentSnapshot.getBoolean("type");
                            distance = documentSnapshot.getDouble("distance");
                            time = documentSnapshot.getDouble("time");
                            if (type == ActivityDTO.MANUAL) {
                                actividadDTO = new ManualActivityDTO(distance, time, calendar);

                            } else {
                                actividadDTO = Utils.saveLocationActivity(documentSnapshot, distance, time, calendar);

                            }
                            callback.onCallback(actividadDTO);

                        } catch (NullPointerException e) {

                        }
                    }
                });


    }





    public void deleteActivity(){
        db.collection("usuarios").document(username).
                collection("año").document(year).collection(month).
                document(day).collection("actividades").document(hour).delete();
        updateActivities();
    }

    private void updateActivities(){
        if (actividadDTO.getDistance()>=3){
            updateNumberOfActivities(-1);
        }

    }


}
